/// @cond EO_CXX_EO_IMPL

inline ::elm::widget_item elm::list::item_insert_before(::elm::widget_item before_, ::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::list::go() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_go());
}

inline ::elm::widget_item elm::list::item_insert_after(::elm::widget_item after_, ::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::list::at_xy_item_get(Evas_Coord x_, Evas_Coord y_, int* posret_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_at_xy_item_get(x_, y_, posret_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::list::item_append(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::list::item_prepend(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_prepend(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::list::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_clear());
}

inline ::elm::widget_item elm::list::item_sorted_insert(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_sorted_insert(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_, cmp_func_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::list::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::list::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline Elm_Object_Select_Mode elm::list::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_select_mode_get());
   return _tmp_ret;
}

inline void elm::list::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_select_mode_set(mode_));
}

inline bool elm::list::focus_on_selection_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_focus_on_selection_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::list::focus_on_selection_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_focus_on_selection_set(::efl::eolian::to_c(enabled_)));
}

inline bool elm::list::multi_select_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_multi_select_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::list::multi_select_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_multi_select_set(::efl::eolian::to_c(multi_)));
}

inline Elm_Object_Multi_Select_Mode elm::list::multi_select_mode_get() const
{
   Elm_Object_Multi_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_multi_select_mode_get());
   return _tmp_ret;
}

inline void elm::list::multi_select_mode_set(Elm_Object_Multi_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_multi_select_mode_set(mode_));
}

inline Elm_List_Mode elm::list::mode_get() const
{
   Elm_List_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_mode_get());
   return _tmp_ret;
}

inline void elm::list::mode_set(Elm_List_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_mode_set(mode_));
}

inline ::elm::widget_item elm::list::selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::list::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item elm::list::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::list::selected_items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_selected_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item elm::list::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::list::item_insert_before(::elm::widget_item before_, ::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::list::go() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_go());
}

inline ::elm::widget_item eo_cxx::elm::list::item_insert_after(::elm::widget_item after_, ::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::list::at_xy_item_get(Evas_Coord x_, Evas_Coord y_, int* posret_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_at_xy_item_get(x_, y_, posret_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::list::item_append(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::list::item_prepend(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_prepend(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::list::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_clear());
}

inline ::elm::widget_item eo_cxx::elm::list::item_sorted_insert(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_item_sorted_insert(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_, cmp_func_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::list::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::list::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline Elm_Object_Select_Mode eo_cxx::elm::list::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::list::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_select_mode_set(mode_));
}

inline bool eo_cxx::elm::list::focus_on_selection_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_focus_on_selection_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::list::focus_on_selection_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_focus_on_selection_set(::efl::eolian::to_c(enabled_)));
}

inline bool eo_cxx::elm::list::multi_select_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_multi_select_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::list::multi_select_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_multi_select_set(::efl::eolian::to_c(multi_)));
}

inline Elm_Object_Multi_Select_Mode eo_cxx::elm::list::multi_select_mode_get() const
{
   Elm_Object_Multi_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_multi_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::list::multi_select_mode_set(Elm_Object_Multi_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_multi_select_mode_set(mode_));
}

inline Elm_List_Mode eo_cxx::elm::list::mode_get() const
{
   Elm_List_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::list::mode_set(Elm_List_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_list_mode_set(mode_));
}

inline ::elm::widget_item eo_cxx::elm::list::selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::list::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::list::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::list::selected_items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_selected_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::list::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_list_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::list::operator ::elm::list() const
{
   return *static_cast<::elm::list const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::list::operator ::elm::list&()
{
   return *static_cast<::elm::list*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::list::operator ::elm::list const&() const
{
   return *static_cast<::elm::list const*>(static_cast<void const*>(this));
}

template <typename T>
::elm::widget_item elm_list_item_insert_before_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * before_, const char * label_, Evas_Object * icon_, Evas_Object * end_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_before(::efl::eolian::to_cxx<::elm::widget_item>(before_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(end_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_list_go_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->go();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_list_item_insert_after_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * after_, const char * label_, Evas_Object * icon_, Evas_Object * end_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_after(::efl::eolian::to_cxx<::elm::widget_item>(after_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(end_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_list_at_xy_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, int* posret_)
{
   try
      {
         return static_cast<T*>(self->this_)->at_xy_item_get(x_, y_, posret_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_list_item_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Object * end_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_append(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(end_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_list_item_prepend_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Object * end_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_prepend(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(end_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_list_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_list_item_sorted_insert_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Object * end_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_sorted_insert(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(end_, std::tuple<std::false_type>()), func_, data_, cmp_func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_list_horizontal_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->horizontal_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_list_horizontal_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   try
      {
         static_cast<T*>(self->this_)->horizontal_set(::efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Object_Select_Mode elm_list_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Object_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_list_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_list_focus_on_selection_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->focus_on_selection_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_list_focus_on_selection_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->focus_on_selection_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_list_multi_select_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->multi_select_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_list_multi_select_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool multi_)
{
   try
      {
         static_cast<T*>(self->this_)->multi_select_set(::efl::eolian::to_cxx<bool>(multi_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Object_Multi_Select_Mode elm_list_multi_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->multi_select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Object_Multi_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_list_multi_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Multi_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->multi_select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_List_Mode elm_list_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_List_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_list_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_List_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_list_selected_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_list_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_list_first_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->first_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_list_selected_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_list_last_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->last_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::list >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_scrollable >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
         , virtual operations< ::elm_interface_atspi_selection >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
         , virtual operations< ::evas::selectable_interface >::template type<T>
   {
      virtual ::elm::widget_item item_insert_before(::elm::widget_item before_, ::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void go()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_go());
      }

      virtual ::elm::widget_item item_insert_after(::elm::widget_item after_, ::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item at_xy_item_get(Evas_Coord x_, Evas_Coord y_, int* posret_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_at_xy_item_get(x_, y_, posret_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_append(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_prepend(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_item_prepend(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_clear());
      }

      virtual ::elm::widget_item item_sorted_insert(::efl::eina::string_view label_, ::evas::object icon_, ::evas::object end_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_item_sorted_insert(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), ::efl::eolian::to_c(end_), func_, data_, cmp_func_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_horizontal_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_horizontal_set(::efl::eolian::to_c(horizontal_)));
      }

      virtual Elm_Object_Select_Mode select_mode_get()
      {
         Elm_Object_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_select_mode_get());
            return _tmp_ret;
      }

      virtual void select_mode_set(Elm_Object_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_select_mode_set(mode_));
      }

      virtual bool focus_on_selection_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_focus_on_selection_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_on_selection_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_focus_on_selection_set(::efl::eolian::to_c(enabled_)));
      }

      virtual bool multi_select_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_multi_select_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void multi_select_set(bool multi_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_multi_select_set(::efl::eolian::to_c(multi_)));
      }

      virtual Elm_Object_Multi_Select_Mode multi_select_mode_get()
      {
         Elm_Object_Multi_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_multi_select_mode_get());
            return _tmp_ret;
      }

      virtual void multi_select_mode_set(Elm_Object_Multi_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_multi_select_mode_set(mode_));
      }

      virtual Elm_List_Mode mode_get()
      {
         Elm_List_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_mode_get());
            return _tmp_ret;
      }

      virtual void mode_set(Elm_List_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_list_mode_set(mode_));
      }

      virtual ::elm::widget_item selected_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_selected_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::elm::widget_item first_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_first_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > selected_items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_selected_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::elm::widget_item last_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_list_last_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::list >
{
   static constexpr int value = 
#if defined(LIST_PROTECTED) && defined(LIST_BETA)
      25
#elif defined(LIST_PROTECTED)
      25
#elif defined(LIST_BETA)
      25
#else
      25
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_scrollable >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value      + operation_description_class_size<::elm_interface_atspi_selection >::value      + operation_description_class_size<::evas::clickable_interface >::value      + operation_description_class_size<::evas::selectable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::list>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_list_item_insert_before_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_item_insert_before);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_go_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_go);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_item_insert_after_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_item_insert_after);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_at_xy_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_at_xy_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_item_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_item_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_item_prepend_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_item_prepend);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_item_sorted_insert_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_item_sorted_insert);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_horizontal_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_horizontal_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_horizontal_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_horizontal_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_focus_on_selection_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_focus_on_selection_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_focus_on_selection_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_focus_on_selection_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_multi_select_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_multi_select_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_multi_select_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_multi_select_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_multi_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_multi_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_multi_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_multi_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_selected_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_selected_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_first_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_first_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_selected_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_selected_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_list_last_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_list_last_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::list >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_scrollable>(), &ops[operation_description_class_size< ::elm::list >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::list >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_selection>(), &ops[operation_description_class_size< ::elm::list >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::list >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value + operation_description_class_size<::elm_interface_atspi_selection>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::selectable_interface>(), &ops[operation_description_class_size< ::elm::list >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value + operation_description_class_size<::elm_interface_atspi_selection>::value + operation_description_class_size<::evas::clickable_interface>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::list>)
{
   return (ELM_LIST_CLASS);
}

} } }

/// @endcond

